Bug 56736 - [chromium] MAC: should pass CSS3 elliptical gradient tests
Summary: [chromium] MAC: should pass CSS3 elliptical gradient tests
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: CSS (show other bugs)
Version: 528+ (Nightly build)
Hardware: Macintosh OS X 10.6
: P2 Normal
Assignee: noel gordon
URL:
Keywords: LayoutTestFailure
Depends on: 51841
Blocks: 55745
  Show dependency treegraph
 
Reported: 2011-03-21 04:17 PDT by noel gordon
Modified: 2012-01-03 20:40 PST (History)
3 users (show)

See Also:


Attachments
Patch (253.97 KB, patch)
2011-12-21 23:11 PST, noel gordon
no flags Details | Formatted Diff | Diff
Patch for landing (253.98 KB, patch)
2011-12-22 18:30 PST, noel gordon
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description noel gordon 2011-03-21 04:17:33 PDT
Following tests are not passing in dumpRenderTree --chromium.  

fast/gradients/css3-radial-gradients.html
fast/gradients/css3-radial-gradients2.html
fast/gradients/css3-radial-gradients3.html
fast/gradients/css3-repeating-radial-gradients.html
Comment 1 noel gordon 2011-03-21 05:01:19 PDT
Chromium currently builds against the OSX 10.5 SDK on both LEOPARD and SNOW LEOPARD, which
causes BUILDING_ON_LEOPARD to be defined via <wtf/Platform.h>.  Gradient.h defines

  #define USE_CG_SHADING defined(BUILDING_ON_TIGER) || defined(BUILDING_ON_LEOPARD)

making the gradient paint path use the older CGShaders - CGShadingCreateRadial is used for
radial gradients, but does not support ellipsoidal gradients (this bug).

Using the newer CGContextDrawRadialGradient for radial gradients would fix the bug, but it
would also cause memory leaks for linear gradients via CGContextDrawLinearGradient on 10.5
SDK builds of the Gradient.h code (refer to changeset 54970).

Best to fix this once Chromium has real 10.6 SDK build/release system (USE_CG_SHADING will
be false) and rebaseline the layout tests to close this bug.
Comment 2 noel gordon 2011-12-21 23:03:40 PST
Alternative fix, use skia on the mac, the skai implementation know how to draws ellipsoids as required by these tests.
Comment 3 noel gordon 2011-12-21 23:11:59 PST
Created attachment 120277 [details]
Patch
Comment 4 noel gordon 2011-12-21 23:22:07 PST
ahem, the skia implementation knows how to draws ellipsoids bug 51841 as required by these tests
Comment 5 Stephen White 2011-12-22 06:48:17 PST
Comment on attachment 120277 [details]
Patch

Thanks!  r=me
Comment 6 noel gordon 2011-12-22 18:30:59 PST
Created attachment 120421 [details]
Patch for landing
Comment 7 Stephen White 2011-12-22 19:05:08 PST
Comment on attachment 120421 [details]
Patch for landing

OK.
Comment 8 WebKit Review Bot 2011-12-23 04:06:05 PST
Comment on attachment 120421 [details]
Patch for landing

Clearing flags on attachment: 120421

Committed r103621: <http://trac.webkit.org/changeset/103621>
Comment 9 WebKit Review Bot 2011-12-23 04:06:10 PST
All reviewed patches have been landed.  Closing bug.